package org.greenstone.gsdl3.gs3build.doctypes;

import java.io.*;
import java.net.*;

import org.greenstone.gsdl3.gs3build.metadata.*;

public class MetadataRecogniser implements RecogniserInterface
{
  DocumentList listRepository;

  public MetadataRecogniser(DocumentList listRepository)
  { this.listRepository = listRepository;
  }

  public boolean parseDocument(METSFile file)
  {
    String MIMEType = file.getMIMEType();
    if (MIMEType == null || 
	MIMEType.equals("text/xml")) {
      URL location = file.getLocation();
      return this.parseDocument(location);
    }
    return false;
  }

  public boolean parseDocument(URL url)
  { String fileName = null;

    if (url.getProtocol().equals("file")) {
      fileName = url.getPath();
    }

    if (fileName != null)
    { if (fileName.endsWith(File.separatorChar + "metadata.xml"))
      {	
	System.out.println("Posting Metadata Document " + fileName);
	MetadataDocument doc = new MetadataDocument(url);
	this.listRepository.addDocument(doc);
	// TODO: spawn knowledge of children too...
	//				System.out.println(doc.getDocumentText());
	return true;
      }
    }
    else {
      // TODO: get Mime type remotely, and then proceed if required
    }
    return false;
  }
}
